Bug 1256377 - Review Request:java-mersenne-twister - Mersenne Twister random number generator in Java
Review Request:java-mersenne-twister - Mersenne Twister random number genera...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jerry James
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-08-24 08:42 EDT by Jonathan Underwood
Modified: 2015-09-06 13:05 EDT (History)
2 users (show)

See Also:
Fixed In Version: 20-4.fc23
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-09-05 21:10:13 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
loganjerry: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
Patch to fix javadoc errors (6.69 KB, patch)
2015-08-24 23:43 EDT, Jerry James
no flags Details | Diff

  None (edit)
Description Jonathan Underwood 2015-08-24 08:42:05 EDT
Spec URL: https://jgu.fedorapeople.org/java-mersenne-twister.spec
SRPM URL: https://jgu.fedorapeople.org/java-mersenne-twister-20-2.fc22.src.rpm
Description: The Mersenne Twister is an exceptionally high-quality, fast random number generator.  This package contains two versions of it in Java, written by Sean Luke.  MersenneTwister is a complete drop-in subclass replacement for java.util.Random.  MersenneTwisterFast is algorithmically identical, except that it isn't synchronized, and it's not a subclass of Random.  This, plus other speed improvements, makes it over twice the speed.
Fedora Account System Username: jgu
Comment 1 Jerry James 2015-08-24 23:25:13 EDT
I will take this review.
Comment 2 Jerry James 2015-08-24 23:43:54 EDT
Created attachment 1066708 [details]
Patch to fix javadoc errors

The build fails in Rawhide because javadoc has gotten pickier about the HTML it will accept.  The attached patch fixes the errors and a couple of the warnings.  I have made no attempt to do anything about the missing @param, @return, and @throws tags.
Comment 3 Jonathan Underwood 2015-08-25 07:00:07 EDT
Spec URL: https://jgu.fedorapeople.org/java-mersenne-twister.spec
SRPM URL: https://jgu.fedorapeople.org/java-mersenne-twister-20-3.fc22.src.rpm


Thanks very much Jerry. I applied your patch, and there was one remaining error, so I fixed that in the modified patch included in this srpm. I'll contact the author and send him the patch.
Comment 4 Jerry James 2015-08-25 22:20:27 EDT
Just to satisfy my curiosity, what was the point of changing the BR:
jpackage-utils to BR: javapackages-tools?  It doesn't appear to me that any of
the tools are actually used.

It's a little odd that the -javadoc subpackage has a Group tag when the main
package does not.  I suggest dropping the Group tag in -javadoc.

There are two SHOULD items that you don't have to address, but, well, should.
- Ask upstream to include a license file.
- Write a %check script

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 2 files have unknown license. Detailed
     output of licensecheck in /home/jamesjer/1256377-java-mersenne-
     twister/licensecheck.txt
[-]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils

Maven:
[-]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: java-mersenne-twister-20-3.fc24.noarch.rpm
          java-mersenne-twister-javadoc-20-3.fc24.noarch.rpm
          java-mersenne-twister-20-3.fc24.src.rpm
java-mersenne-twister.noarch: W: spelling-error %description -l en_US util -> til, until, u til
java-mersenne-twister.noarch: W: spelling-error %description -l en_US algorithmically -> algorithmic ally, algorithmic-ally, algorithmic
java-mersenne-twister.noarch: W: no-documentation
java-mersenne-twister.src: W: spelling-error %description -l en_US util -> til, until, u til
java-mersenne-twister.src: W: spelling-error %description -l en_US algorithmically -> algorithmic ally, algorithmic-ally, algorithmic
3 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
java-mersenne-twister.noarch: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
java-mersenne-twister (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils

java-mersenne-twister-javadoc (rpmlib, GLIBC filtered):
    java-mersenne-twister
    jpackage-utils



Provides
--------
java-mersenne-twister:
    java-mersenne-twister

java-mersenne-twister-javadoc:
    java-mersenne-twister-javadoc



Source checksums
----------------
http://www.cs.gmu.edu/~sean/research/mersenne/MersenneTwister.java :
  CHECKSUM(SHA256) this package     : 4be4607e6728278c02e3d402339d78a3833ca81ef59cb0a8fcdcb0bc425fcfbf
  CHECKSUM(SHA256) upstream package : 4be4607e6728278c02e3d402339d78a3833ca81ef59cb0a8fcdcb0bc425fcfbf
http://www.cs.gmu.edu/~sean/research/mersenne/MersenneTwisterFast.java :
  CHECKSUM(SHA256) this package     : 99542fae6aea1d170a747db7833bf3753b262224c64b08de5d09ef110db63d27
  CHECKSUM(SHA256) upstream package : 99542fae6aea1d170a747db7833bf3753b262224c64b08de5d09ef110db63d27


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1256377 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

There are no outstanding MUST items, so this package is APPROVED.
Comment 5 Jonathan Underwood 2015-08-26 07:06:36 EDT
(In reply to Jerry James from comment #4)
> Just to satisfy my curiosity, what was the point of changing the BR:
> jpackage-utils to BR: javapackages-tools?  It doesn't appear to me that any
> of
> the tools are actually used.
> 

Simply that jpackage-utils was renamed to javapackages-tools which Provides jpackage-utils (afaics anyway).

> It's a little odd that the -javadoc subpackage has a Group tag when the main
> package does not.  I suggest dropping the Group tag in -javadoc.
> 

OK, will do.

> There are two SHOULD items that you don't have to address, but, well, should.
> - Ask upstream to include a license file.

Well... as you know upstream doesn't distribute these as a packaged tarball or anything, simply making the two files available for download, so I'm not sure it makes much sense to ask. I'll mention it anyway, when I send the patch.

> - Write a %check script
> 

Will give that some thought.


Many thanks for the review, and the work on the original package!
Comment 6 Jonathan Underwood 2015-08-26 07:08:46 EDT
New Package SCM Request
=======================
Package Name: java-mersenne-twister
Short Description: Mersenne Twister random number generator in Java
Upstream URL: http://www.cs.gmu.edu/~sean/research/
Owners: jgu
Branches: f21 f22 f23
InitialCC:
Comment 7 Gwyn Ciesla 2015-08-26 09:25:08 EDT
Git done (by process-git-requests).
Comment 8 Fedora Update System 2015-08-28 08:53:00 EDT
java-mersenne-twister-20-4.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-14488
Comment 9 Fedora Update System 2015-08-28 09:04:00 EDT
java-mersenne-twister-20-4.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-14490
Comment 10 Fedora Update System 2015-08-28 09:05:23 EDT
java-mersenne-twister-20-4.fc21 has been submitted as an update to Fedora 21. https://bodhi.fedoraproject.org/updates/FEDORA-2015-14491
Comment 11 Fedora Update System 2015-08-28 14:53:01 EDT
java-mersenne-twister-20-4.fc21 has been pushed to the Fedora 21 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update java-mersenne-twister'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-14491
Comment 12 Fedora Update System 2015-08-28 14:57:27 EDT
java-mersenne-twister-20-4.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update java-mersenne-twister'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-14490
Comment 13 Fedora Update System 2015-08-31 14:52:21 EDT
java-mersenne-twister-20-4.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update java-mersenne-twister'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-14488
Comment 14 Fedora Update System 2015-09-05 21:10:10 EDT
java-mersenne-twister-20-4.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 15 Fedora Update System 2015-09-06 00:49:52 EDT
java-mersenne-twister-20-4.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.
Comment 16 Fedora Update System 2015-09-06 02:20:24 EDT
java-mersenne-twister-20-4.fc21 has been pushed to the Fedora 21 stable repository. If problems still persist, please make note of it in this bug report.
Comment 17 Fedora Update System 2015-09-06 13:05:14 EDT
java-mersenne-twister-20-4.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.